## aot-wine-x11-novnc-docker

![Docker Image Size (tag)](https://img.shields.io/docker/image-size/skylord123/aot-wine-x11-novnc-docker/latest)
![Docker Pulls](https://img.shields.io/docker/pulls/skylord123/aot-wine-x11-novnc-docker)

This docker image will run AgeOfTime game client under wine in an Ubuntu container with a novnc server for you to view the application. Uses supervisor to automatically restart failed processes.

Runs a small script in the background that will automatically kill the process if a wine "Program Error" dialog is displayed (since it starts winedbg instead of just quitting).
This script also runs cpulimit against the PID of the AgeOfTime.exe process to limit how much CPU it can consume (only if `AOT_CPU_LIMIT` env variable is defined and not zero).

This container runs:

* Xvfb - X11 in a virtual framebuffer
* x11vnc - A VNC server that scrapes the above X11 server
* [noNVC](https://kanaka.github.io/noVNC/) - A HTML5 canvas vnc viewer
* pulseaudio - Audio server (AOT crashes without proper audio)
* audiostream & websockify_audio - these are supposed to pass audio to the VNC web session but currently doesn't work
* Fluxbox - a small window manager
* AgeOfTime.exe - The game executable

This is a [trusted build](https://registry.hub.docker.com/u/skylord123/aot-wine-x11-novnc-docker/)
on the Docker Hub.

## Run It

Modify your docker-compose.yml file then:

    docker compose up

Go to `http://localhost:8080` in your browser and you should see AgeOfTime boot up.

## Issues

* Audio isn't working correctly. Keeps crashing when supservisor tries to start it and shortly gives up.
* Console output of game isn't being sent to the contrainer stdout (would be nice to fix this so the container logs show the game logs)